SystemOrganization addCategory: #PacMan!

TestCase subclass: #PacManTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!PacManTest class methodsFor: 'accessing' stamp: 'JuanManuelTastzian 4/29/2013 21:14'!
blueGhost
	^Ghost blue! !

!PacManTest methodsFor: 'actors' stamp: 'JuanManuelTastzian 4/29/2013 21:12'!
blueGhost

	^Ghost new! !

!PacManTest methodsFor: 'actors' stamp: 'JuanManuelTastzian 4/29/2013 21:13'!
blueberry

	^Fruit new! !

!PacManTest methodsFor: 'movements' stamp: 'JuanManuelTastzian 4/29/2013 21:33'!
down

	^self position + (0 @ -1)! !

!PacManTest methodsFor: 'construction block types' stamp: 'JuanManuelTastzian 4/29/2013 21:35'!
ghostHouseDoorType

	^GhostHouseDoorType new! !

!PacManTest methodsFor: 'movements' stamp: 'JuanManuelTastzian 4/29/2013 21:33'!
left

	^self position + (-1 @ 0)! !

!PacManTest methodsFor: 'construction block types' stamp: 'JuanManuelTastzian 4/29/2013 21:41'!
leftTransporterType

	^Transporter left! !

!PacManTest methodsFor: 'actors' stamp: 'JuanManuelTastzian 4/29/2013 20:36'!
pacman

	^Pacman new! !

!PacManTest methodsFor: 'accessing' stamp: 'JuanManuelTastzian 4/29/2013 21:34'!
position
	^0 @ 0! !

!PacManTest methodsFor: 'movements' stamp: 'JuanManuelTastzian 4/29/2013 21:34'!
right

	^self position + (1 @ 0)! !

!PacManTest methodsFor: 'construction block types' stamp: 'JuanManuelTastzian 4/29/2013 21:15'!
spaceType

	^SpaceType new
! !

!PacManTest methodsFor: 'tests' stamp: 'JuanManuelTastzian 4/29/2013 20:35'!
test01GhostCanNotGoIntoAWall

	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self right ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self up ).
	self assert: self blueGhost position equals: ( self wallType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test02PacmanCanNotGoIntoAWall

	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self wallType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:38'!
test02aFruitCanNotGoIntoAWall

	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self left ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self right ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self up ).
	self assert: self blueberry position equals: ( self wallType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test03GhostMovesIntoSpaces

	self assert: ( self blueGhost position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self left ).
	self assert: ( self blueGhost position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:31'!
test04PacmanMovesIntoSpaces

	self assert: ( self pacman position + (-1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self left ).
	self assert: ( self pacman position +  (1@0) ) equals: ( self spaceType nextPositionFor: self pacman going: self right ).
	self assert: ( self pacman position +  (0@1) ) equals: ( self spaceType nextPositionFor: self pacman going: self up ).
	self assert: ( self pacman position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self pacman going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:39'!
test04aFruitMovesIntoSpaces

	self assert: ( self blueberry position + (-1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self left ).
	self assert: ( self blueberry position +  (1@0) ) equals: ( self spaceType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: ( self spaceType nextPositionFor: self blueberry going: self down ).

! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test05GhostCanEnterHisHouse

	self assert: ( self blueGhost position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self left).
	self assert: ( self blueGhost position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self right ).
	self assert: ( self blueGhost position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self up ).
	self assert: ( self blueGhost position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueGhost going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test06PacmanCanNotEnterGhostHouse

	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self left ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self right ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self up ).
	self assert: self pacman position equals: ( self ghostHouseDoorType nextPositionFor: self pacman going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:40'!
test06aFruitCanEnterHisHouse

	self assert: ( self blueberry position + (-1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self left).
	self assert: ( self blueberry position +  (1@0) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self right ).
	self assert: ( self blueberry position +  (0@1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self up ).
	self assert: ( self blueberry position + (0@ -1) ) equals: (self ghostHouseDoorType nextPositionFor: self blueberry going: self down ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test07GhostCanNotGoIntoTransporter

	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self left ).
	self assert: self blueGhost position equals: ( self leftTransporterType nextPositionFor: self blueGhost going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:30'!
test08TransporterMovesPacmanToNewPosition

	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self left ).
	self assert: (3@10) equals: ( self leftTransporterType nextPositionFor: self pacman going: self right ).
! !

!PacManTest methodsFor: 'tests' stamp: 'HernanWilkinson 5/16/2012 16:46'!
test09TransporterMovesFruitToNewPosition

	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self left ).
	self assert: (5@10) equals: ( self leftTransporterType nextPositionFor: self blueberry going: self right ).
! !

!PacManTest methodsFor: 'movements' stamp: 'JuanManuelTastzian 4/29/2013 21:33'!
up

	^self position + (0 @ 1)! !

!PacManTest methodsFor: 'construction block types' stamp: 'JuanManuelTastzian 4/29/2013 21:02'!
wallType

	^WallType new! !

Object subclass: #Fruit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Fruit methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/6/2013 17:47'!
goingThroughAGhostHouseDoorTypeAt: aPoint
	^self position + aPoint! !

!Fruit methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/6/2013 17:30'!
goingThroughATransporterAt: aPoint
	^5 @ 10! !

!Fruit methodsFor: 'accessing' stamp: 'JuanManuelTastzian 4/29/2013 21:00'!
position
	^0 @ 0! !

Object subclass: #Ghost
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Ghost class methodsFor: 'accessing' stamp: 'JuanManuelTastzian 4/29/2013 21:14'!
blue
	^self new! !

!Ghost methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/6/2013 17:46'!
goingThroughAGhostHouseDoorTypeAt: aPoint
	^self position + aPoint! !

!Ghost methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/6/2013 17:31'!
goingThroughATransporterAt: aPoint
	^self position! !

!Ghost methodsFor: 'accessing' stamp: 'JuanManuelTastzian 4/29/2013 19:54'!
position
	^(0@ 0)! !

Object subclass: #GhostHouseDoorType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!GhostHouseDoorType methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/6/2013 17:47'!
nextPositionFor: anActor going: aPoint 
	^anActor goingThroughAGhostHouseDoorTypeAt: aPoint! !

Object subclass: #Pacman
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Pacman methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/6/2013 17:47'!
goingThroughAGhostHouseDoorTypeAt: aPoint
	^self position! !

!Pacman methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/6/2013 17:31'!
goingThroughATransporterAt: aPoint
	^3 @ 10! !

!Pacman methodsFor: 'accessing' stamp: 'JuanManuelTastzian 4/29/2013 20:37'!
position
	^(0@ 0)! !

Object subclass: #SpaceType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!SpaceType methodsFor: 'accessing' stamp: 'JuanManuelTastzian 4/29/2013 21:19'!
nextPositionFor: anActor going: aDirection
	^anActor position + aDirection! !

Object subclass: #Transporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!Transporter class methodsFor: 'accessing' stamp: 'JuanManuelTastzian 4/29/2013 21:41'!
left
	^self new! !

!Transporter methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/6/2013 17:45'!
nextPositionFor: anActor going: aPoint 
	^anActor goingThroughATransporterAt: aPoint! !

Object subclass: #WallType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PacMan'!

!WallType methodsFor: 'accessing' stamp: 'JuanManuelTastzian 5/6/2013 17:44'!
nextPositionFor: anActor going: aPoint 
	^anActor position! !
